/* 
 *  DHT11 readout
 * VLAD MIHAI PLACINTA */


#include "DHT.h"    // need to be included

#define DHTPIN 8        // what digital pin we're connected to

#define DHTTYPE DHT11   // DHT 11 senzor

DHT dht(DHTPIN, DHTTYPE);

int AByte = 0;         // UART buffer
int led_warning = 12; // set a led for warning when the temperature exceds a value
int temp_limit = 40;  // temperature limit

void setup() {
  Serial.begin(115200);  // UART initialization: 115200 baud
  pinMode(led_warning, OUTPUT);
  dht.begin();   //DHT sensor initialization
}

void loop() {
  
    AByte = Serial.read();  
  
    
   float h = dht.readHumidity();  //read umidity
 
   float t = dht.readTemperature();  //reat temp Celsius
   
                               
  if (isnan(h) || isnan(t)) {  // Check if any reads failed and exit early (to try again).
    
    return;
  }

 if (AByte == 'A' )  { // if A char is received from UART/LabVIEW, then send the data
   
  Serial.print('Z');  //sync char
  Serial.print(h);
  Serial.print('\n');
  Serial.print(t);
  Serial.print('\n'); 
  }
  
  
  if (t > 40){                         //if temperature value exceds the limit, then turn the led on, else keep it off
  digitalWrite(led_warning, HIGH);
  
  }
 else
  {
 digitalWrite(led_warning, LOW);
  }

delay(500);  //delay  500 ms
}



